#include <SPI.h>
#include <DW1000.h>


/* SENDER */

int ss = 53;
int rstpin = 9;

int iter = 0;
long temp;

DW1000 dw = DW1000(ss, rstpin);

void setup() {
  Serial.begin(9600);
  dw.initialise();
  
  randomSeed(analogRead(0));
  Serial.println("Initialisation complete!");
}

void loop() {
  Serial.println(); Serial.print("------------------ #"); Serial.println(iter);
  
  // set transmission config
  dw.setTxFrameControl(0x0015400C);
  long randNumber = random(10000);
  dw.writeTxBuffer(0, randNumber, 4);
  
  // start transmission
  dw.startTx();
  delay(10);
  
  // print tx buffer
  Serial.println();
  Serial.print("tx buffer: "); dw.printAnythingln(0x09, 0, 0, 4);
  
  // print tx status
  Serial.println();
  Serial.print("tx status: ");
  dw.printAnything(0x0F, 1, 4, 1); Serial.print("-"); dw.printAnythingln(0x0F, 0, 0, 4);
  
  Serial.println();
  Serial.print("tx time: ");
  dw.printAnything(0x17, 1, 4, 1); Serial.print("-"); dw.printAnythingln(0x17, 0, 0, 4);

  // clear transmission bits
  dw.clearSystemStatus(SYS_MASK_MTXFRB);
  dw.clearSystemStatus(SYS_MASK_MTXPRS);
  dw.clearSystemStatus(SYS_MASK_MTXPHS);
  dw.clearSystemStatus(SYS_MASK_MTXFRS);
  
  delay(2000);
  iter++;
}
